<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.9.0 - Last modified 2014-04-06

WARNING:
Do NOT put sensitive information into this script!
*/


// Load bootstrap
define('BOOT', 1);
require 'boot.php';


// Diagnosics backdoor.
if (!$flags['owner']) {
	if (!isset($cfg['salt']) || w_gpc('pass') != $cfg['salt']) {
		report_err('Diagnostics page available only to owner');
	}
}
if (isset($_GET['php'])) {
	phpinfo();
	w_exit();
}


// Get member
$member_info = array();


// Get DB
$db_info = array();
$limit_quanity = 6;
{
	$result = db_query("SELECT miscstring FROM {$db_p}oekakimisc WHERE miscname='dbversion'");
	$db_info['DB version'] = db_result($result);

	$result = db_query("SELECT COUNT(ID_2) FROM {$db_p}oekakidta");
	$db_info['Total pics'] = (int) db_result($result)." (out of {$cfg['pic_store']})";

	$result = db_query("SELECT COUNT(ID_2) FROM {$db_p}oekakidta WHERE archive=1");
	$db_info['Archives'] = (int) db_result($result);

	$result = db_query("SELECT COUNT(ID_2) FROM {$db_p}oekakidta WHERE postlock=0");
	$db_info['Recovery'] = (int) db_result($result);

	$result = db_query("SELECT miscvalue FROM {$db_p}oekakimisc WHERE miscname='piccount'");
	$db_info['Current picture number'] = (int) db_result($result);

	$temp = array();
	$result = db_query("SELECT PIC_ID FROM {$db_p}oekakidta ORDER BY ID_2 DESC LIMIT {$limit_quanity}");
	if ($result) {
		$rows = db_num_rows($result);
		for ($i = 0; $i < $rows; $i++) {
			$temp[] = (int) db_result($result, $i);
		}
		$temp[] = '(Newest first)';
		$db_info['Newest '.$limit_quanity.' pictures'] = make_list($temp, ', ');
	}

	$temp = array();
	$result = db_query("SELECT PIC_ID FROM {$db_p}oekakidta ORDER BY ID_2 ASC LIMIT {$limit_quanity}");
	if ($result) {
		$rows = db_num_rows($result);
		for ($i = 0; $i < $rows;  $i++) {
			$temp[] = (int) db_result($result, $i);
		}
		$temp[] = '(Oldest first)';
		$db_info['Oldest '.$limit_quanity.' pictures'] = make_list($temp, ', ');
	}
}


// Get Locks
{
	$lock_info = array(
		"./" => 0,
		"./{$cfg['op_pics']}/"       => 0,
		"./{$cfg['tpl_path']}/"      => 0,
		"./{$cfg['res_path']}/"      => 0,
		"./{$cfg['avatar_folder']}/" => 0,
		"./config.php"   => 0,
		"./dbconn.php"   => 0,
		"./announce.php" => 0,
		"./banner.php"   => 0,
		"./hosts.txt"    => 0,
		"./ips.txt"      => 0,
		"./notice.php"   => 0
//		"./rules.php"    => 0
	);

	foreach($lock_info as $name => $value) {
		if (file_exists($name)) {
			if (!is_writable($name)) {
				$lock_info[$name] = 1;
			}
		} else {
			$lock_info[$name] = 2;
		}
	}
}


include 'header.php';


?>
<div id="contentmain">
	<h1 class="header">
		DB info
	</h1>
	<div class="infotable">
		<table class="infomain" style="margin-left: 30pt;">
<?php foreach($db_info as $name => $value) { ?>
		<tr>
		<td class="infoask" align="right">
			<?php echo $name;?>:
		</td>
		<td class="infoenter">
			<?php echo $value;?> 
		</td>
		</tr>
<?php }
unset($db_info);
?>

		</table>
	</div>
	<br />


	<h1 class="header">
		Config
	</h1>
	<div class="infotable">
		<table class="infomain" style="margin-left: 30pt;">
		<td class="infoask" align="right">
			PHP Information:
		</td>
		<td class="infoenter">
			<?php echo phpversion()." <a href=\"{$_SERVER['PHP_SELF']}?php=1\">(click for more details)</a>";?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Config version:
		</td>
		<td class="infoenter">
			<?php echo $cfg['version'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Encryption Key (salt):
		</td>
		<td class="infoenter">
			<?php echo $cfg['salt'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Contact:
		</td>
		<td class="infoenter">
			<?php echo $cfg['op_email'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Path to OP:
		</td>
		<td class="infoenter">
			<?php echo $cfg['op_url'] ?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Cookie path:
		</td>
		<td class="infoenter">
			<?php ne_echo($cookie_path, '(empty)');?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Cookie domain:
		</td>
		<td class="infoenter">
			<?php ne_echo($cookie_domain, '(empty)');?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Cookie life:
		</td>
		<td class="infoenter">
			<?php echo $cookie_life ?> seconds (~ <?php echo intval($cookie_life / 86400);?> days)
		</td>
		</tr>
		</table>
	</div>
	<br />


<?php
	// Get pictures folder info
	$picinfo = getImageDirStats($cfg['op_pics']);
?>
	<h1 class="header">
		Pictures folder
	</h1>
	<div class="infotable">
<?php if (!empty($picinfo['err'])) { ?>
		<table class="infomain" style="margin-left: 30pt;">
		<tr>
		<td class="infoask" align="right" width="40%">
			Notice:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['err'];?> 
		</td>
		</tr>
		</table>
<?php } else { ?>
		<table class="infomain" style="margin-left: 30pt;">
		<tr>
		<td class="infoask" align="right">
			Folder:
		</td>
		<td class="infoenter">
			<?php echo $cfg['op_pics'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Total files:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['total'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Total space used:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['total_size'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Average file size:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['avg_size'];?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Images:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['img'].' ('.getTotalPer($picinfo['img'], $picinfo['total']).'%)';?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Animations:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['anim'].' ('.getTotalPer($picinfo['anim'], $picinfo['total']).'%)';?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.PNG:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['png'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.JPG:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['jpg'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.GIF:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['gif'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.PCH:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['pch'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.OEB:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['oeb'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.CHI:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['chi'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Other filetypes:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['other'];?> 
		</td>
		</tr>
		</table>
<?php } ?>
	</div>
	<br />


<?php
	// Get avatars folder info
	$picinfo = getImageDirStats($cfg['avatar_folder']);
?>
	<h1 class="header">
		Avatars folder
	</h1>
	<div class="infotable">
<?php if (!empty($picinfo['err'])) { ?>
		<table class="infomain" style="margin-left: 30pt;">
		<tr>
		<td class="infoask" align="right" width="40%">
			Notice:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['err'];?> 
		</td>
		</tr>
		</table>
<?php } else { ?>
		<table class="infomain" style="margin-left: 30pt;">
		<tr>
		<td class="infoask" align="right">
			Folder:
		</td>
		<td class="infoenter">
			<?php echo $cfg['avatar_folder'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Total files:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['total'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Total space used:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['total_size'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Average file size:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['avg_size'];?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Images:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['img'].' ('.getTotalPer($picinfo['img'], $picinfo['total']).'%)';?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Animations:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['anim'].' ('.getTotalPer($picinfo['anim'], $picinfo['total']).'%)';?> 
		</td>
		</tr>

		<tr>
		<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.PNG:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['png'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.JPG:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['jpg'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			.GIF:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['gif'];?> 
		</td>
		</tr>

		<tr>
		<td class="infoask" align="right">
			Other filetypes:
		</td>
		<td class="infoenter">
			<?php echo $picinfo['other'];?> 
		</td>
		</tr>
		</table>
<?php } ?>
	</div>
	<br />


	<h1 class="header">
		Locks
	</h1>
	<div class="infotable">
		<table class="infomain" style="margin-left: 30pt;">
<?php foreach($lock_info as $name => $value) { ?>
		<tr>
		<td class="infoask" align="right">
			<?php echo $name;?> 
		</td>
		<td class="infoenter">
			<?php
			if ($value == 0) {
				echo 'OK';
			} elseif ($value == 1) {
				echo '<strong>Locked</strong>';
			} else {
				echo '<strong>Missing</strong>';
			}
			?> 
		</td>
		</tr>
<?php }
unset($lock_info);
?>

		</table>
	</div>
	<br />


</div>
<?php

include 'footer.php';



//
// FUNCTIONS
//

function getTotalPer($in, $total) {
	if ($total == 0) {
		return $in;
	}

	$out = ((float) $in / (float) $total) * 100.0;
	return sprintf('%5.1f', $out);
}

function getImageDirStats($dir) {
	$f_total = 0;
	$f_kilo  = 0;
	$f_img   = 0;
	$f_anim  = 0;
	$f_other = 0;
	$f_png   = 0;
	$f_gif   = 0;
	$f_jpg   = 0;
	$f_pch   = 0;
	$f_oeb   = 0;
	$f_chi   = 0;
	$err = '';

	if (! ($handle = @opendir($dir))) {
		$err = t('d_no_read_dir');
	} else { 
		while (false !== ($file = readdir($handle))) {
			$dot = strpos($file, '.');

			// Don't include hidden files or text/code files
			if ($file != 'index.php' && $dot !== false && $dot != 0) {
				$f_total++;
				$size = filesize($dir.'/'.$file);
				if ($size > 0) {
					// PHP doesn't support long (!), so use KB, so we don't overflow
					$f_kilo += intval($size / 1024);
				}

				// Only 3 char extensions
				$ext = substr($file, -3);

				switch ($ext) {
					case 'gif':
						$f_gif++;
						$f_img++;
						break;

					case 'jpg':
						$f_jpg++;
						$f_img++;
						break;

					case 'png':
						$f_png++;
						$f_img++;
						break;

					case 'pch':
						$f_pch++;
						$f_anim++;
						break;

					case 'oeb':
						$f_oeb++;
						$f_anim++;
						break;

					case 'chi':
						$f_chi++;
						$f_anim++;
						break;

					default:
						$f_other++;
						break;
				}
			}
		}
		closedir($handle);


		// Div by zero
		if ($f_total < 1) {
			$err = t('d_folder_empty');
		} else {
			$total_size = '';
			$avg_size   = '';

			// Totals
			$total_size .= $f_kilo.'KB';
			$t_megabytes = (float) $f_kilo / 1024.0;
			if ($t_megabytes > 1.0) {
				$total_size .= ' ('.sprintf('%01.1f', $t_megabytes).'MB)';
			}

			// Averages
			$avg_size .= intval($f_kilo / $f_total).'KB';
		}
	}

	return array(
		'total'      => $f_total,
		'total_size' => $total_size,
		'avg_size'   => $avg_size,
		'kilo'  => $f_kilo,
		'img'   => $f_img,
		'anim'  => $f_anim,
		'other' => $f_other,
		'png'   => $f_png,
		'gif'   => $f_gif,
		'jpg'   => $f_jpg,
		'pch'   => $f_pch,
		'oeb'   => $f_oeb,
		'chi'   => $f_chi,
		'err'   => $err
	);
}